
#include "common.h"
#include "Console.h"
#include "Player.h"
#include "Enemy.h"
#include "EnemyManager.h"	//	߰
#include "Shot.h"

Player player;

#define MAX_SHOT_COUNT      30						
Shot Shots[MAX_SHOT_COUNT];	

void InitialObject(void);
void PlayerAction(void);
void DrawPlayer(void);
void Draw(void);
void EnemyAction(void);
void DrawEnemy(void);
void CreateShot(int Type, int x, int y);
void ShotAction(void);
void DrawShot(void);
void CheckCrush(void);
int CheckClear(void);
int CheckGameEnd(void);

int main(void)
{
	Initial();				//	ܼ ȭ â ʱȭ
	InitialObject();		//	Ʈ ʱȭ
	
	srand( (unsigned int)time(NULL) );

	while (1) 
	{
		PlayerAction();		//	÷̾ ̵
		EnemyAction();		//	ʹ ̵
		ShotAction();		//	÷̾&ʹ Ѿ ̵

		Draw();				//	Ʈ ܼȭ鿡 
		
		CheckCrush();		//	浹üũ
		
		//	   üũ
		if (CheckGameEnd()) 
			break;

		Sleep(100);
	}

	return 0;
}

void InitialObject(void)
{
	int i;

	EnemyManager::GetInstance()->Init();
	
	player.Init(39,19);
	
	//	Shot Ŭ ڿ ʱȭ ϹǷ ʿ .
	//for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	//	Shot[i].UseFlag = 0;
}

void PlayerAction(void)
{
	player.PlayerAction();
}

void DrawPlayer(void)
{
	player.DrawPlayer();
}

void Draw(void)
{
	int i;
	
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		memset(Screen[i], ' ', WIDTH);	
		Screen[i][WIDTH - 1] = 0;		
	}
	
	DrawPlayer();
	
	DrawEnemy();		
	
	DrawShot();			

	for ( i = 0; i < HEIGHT; i++ ) 
	{
		MoveCursor(0, i);		
		printf( Screen[i] );	
	}
}

void EnemyAction(void)
{
	EnemyManager::GetInstance()->EnemyAction();
}

void DrawEnemy(void)
{
	EnemyManager::GetInstance()->DrawEnemy();
}

void CreateShot(int Type, int x, int y)
{
	int i;
	
	//	Ѿ 
	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shots[i].GetUseFlag() == 0 ) 
		{
			Shots[i].CreateShot( x, y, Type );
			
			return;	
		}
	}
}

void ShotAction(void)
{
	int i;
	
	//	Ѿ˵ ̵
	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		Shots[i].ShotAction();
	}
}

void DrawShot(void)
{
	int i;
	
	//	Ѿ˵ 
	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		Shots[i].DrawShot();
	}
}

void CheckCrush(void)
{
	int i;
	
	//	Ʈ Ѿ 浹 üũ
	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{ 
		if ( Shots[i].GetUseFlag() == 0 ) 
			continue;
		
		if ( Shots[i].GetType() == PLAYER_SHOT ) 
		{
			if ( EnemyManager::GetInstance()->CollisionWithShot( Shots[i].GetX(), Shots[i].GetY() ) )
			{
				Shots[i].SetUseFlag(0);	//	Ѿ 
			}
		}
		else if ( Shots[i].GetType() == ENEMY_SHOT ) 
		{
			if ( player.CollisionWithShot( Shots[i].GetX(), Shots[i].GetY() ) )
			{
				Shots[i].SetUseFlag(0);	//	Ѿ 	
			}
		}
	}
}

int CheckClear(void)
{
	return EnemyManager::GetInstance()->CheckClear();
}

int CheckGameEnd(void)
{
	if ( player.GetLiveFlag() == 0 ) 
	{
		system("cls");
		MoveCursor(36, 12);
		printf(" !!");
		Sleep(1000);

		return 1;	
	}
	
	if ( CheckClear() ) 
	{
		system("cls"); 
		MoveCursor(36, 12);
		printf(" ̰!!");
		Sleep(1000);

		return 1;	
	}
	
	return 0;
}